#include <bits/stdc++.h> 
using namespace std; 
  
int n, m;
vector<pair<int, pair<int,int> > > edges; // obsahuje hrany ve formatu <vaha, <u,v> >
int parent[123456];
int rnk[123456];
  

int find(int u){ // najde reprezentanta komponenty daného vrcholu, cestou probíhá kontrakce hran
    if (u != parent[u]) parent[u] = find(parent[u]); 
    return parent[u]; 
} 
  
void merge(int u, int v){ // spojí dvě komponenty do jedné
    u = find(u);
    v = find(v); 

    if(rnk[u] > rnk[v]) parent[v] = u; 
    else parent[u] = v; 

    if (rnk[u] == rnk[v]) rnk[v]++; 
} 


int main(){ 
    cin >> n >> m;
    for(int i = 1; i <= n; ++i){ // ceny elektráren interpretujeme jako hrany do speciálního vrcholu 0
        int w;
        cin >> w;
        edges.push_back({w, {0, i}});
    }

    for(int i = 0; i < m; ++i){
        int u, v, w;
        cin >> u >> v >> w;
        edges.push_back({w, {u, v}});
    }

    for (int i = 0; i <= n; i++){ // inicializujeme DFU strukturu 
        rnk[i] = 0; 
        parent[i] = i; 
    } 

    long long ans = 0; // výsledná váha
  
    sort(edges.begin(), edges.end()); // seřadíme hrany podle jejich váhy
  
    for(int i = 0; i < edges.size(); ++i){
        int u = edges[i].second.first;
        int v = edges[i].second.second;
        int w = edges[i].first;

        int ru = find(u); // najdeme reprezentanty komponenty u a v
        int rv = find(v);

        if(ru != rv){ // jestliže jsou vrcholy zatím v jiných komponentách
            ans += w;
            merge(ru, rv);
        }
    }

    cout << ans << endl;

    return 0; 
} 
